{TSerLabel : Enhanced TLabel V1.0 by Serguey Avanesov
 Features : It has different variants of TextStyle (Recessed,
            Flat, Raised, Shadow), also some problems with AutoSizing
            in the original component (TLabel) were fixed (AutoSize
            works in different resolutions).
 Status : Freeware
 e-mail : jsoft@estpak.ee
 http://www.estpak.ee/~jsoft/ser.htm }
unit SerLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Common;

type
  TTextStyle = (tsNone, tsRaised,tsRecessed,tsShadow);
  TSerLabel = class(TLabel)
  private
    { Private declarations }
    FTextStyle : TTextStyle;
    FShadowColor : TColor;
    FShadowDepth : Integer;
    procedure SetTextStyle(Value : TTextStyle);
    procedure SetShadowColor(Value : TColor);
    procedure SetShadowDepth(Value : Integer);
    procedure Draw3dText(R : TRect; Flags : Word);
  protected
    { Protected declarations }
    procedure Paint;override;
  public
    { Public declarations }
    constructor Create(AOwner : TComponent);override;
  published
    { Published declarations }
    property ShadowColor : TColor
    read FShadowColor
    write SetShadowColor
    default clBtnShadow;

    property ShadowDepth : Integer
    read FShadowDepth
    write SetShadowDepth
    default 2;

    property TextStyle : TTextStyle
    read FTextStyle
    write SetTextStyle
    default tsRecessed;
  end;

procedure Register;

implementation

constructor TSerLabel.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FTextStyle := tsRecessed;
  FShadowDepth := 2;
  FShadowColor := clBtnShadow;
end;

procedure TSerLabel.SetShadowColor(Value : TColor);
begin
  if Value <> FShadowColor then
  begin
    FShadowColor := Value;
    Invalidate;
  end;
end;

procedure TSerLabel.SetShadowDepth(Value : Integer);
begin
  if Value <> FShadowDepth then
  begin
    FShadowDepth := Value;
    Invalidate;
  end;
end;

procedure TSerLabel.SetTextStyle( Value : TTextStyle);
begin
  if Value <> FTextStyle then
  begin
    FTextStyle := Value;
    Invalidate;
  end;
end;

procedure TSerLabel.Draw3dText(R : TRect; Flags : Word);
var
  CaptionStz   : array [0..255] of Char;
  TempRct      : TRect;
  ULColor      : TColor;
  LRColor      : TColor;
begin
  with Canvas do
  begin
    StrPCopy(CaptionStz,Caption);
    if WordWrap then
      Flags := Flags or dt_WordBreak;
    if not ShowAccelChar then
      Flags := Flags or dt_NoPrefix;
    Font := Self.Font;
    if FTextStyle in [tsRecessed,tsRaised] then
    begin
      case FTextStyle of
           tsRaised   : begin
                          ULColor := clBtnHighLight;
                          LRColor := clBtnShadow;
                        end;
           tsRecessed : begin
                          ULColor := clBtnShadow;
                          LRColor := clBtnHighLight;
                        end;
      end;

      TempRct := R;
      OffsetRect(TempRct,1,1);
      Font.Color := LRColor;
      DrawText(Handle,CaptionStz,-1,TempRct,Flags);

      TempRct := R;
      OffsetRect(TempRct,-1,-1);
      Canvas.Font.Color := ULColor;
      DrawText(Handle,CaptionStz,-1,TempRct,Flags);
    end
    else if FTextStyle = tsShadow then
    begin
      TempRct := R;
      OffsetRect(TempRct,FShadowDepth,FShadowDepth);
      Font.Color := FShadowColor;
      DrawText(Handle,CaptionStz,-1,TempRct,Flags);
    end;
    Font.Color := Self.Font.Color;
    if not Enabled then
      Font.Color := clGrayText;
    DrawText(Handle,CaptionStz,-1,R,Flags);
  end;
end;

procedure TSerLabel.Paint;
begin
  with Canvas do
  begin
    if not Transparent then
    begin
      Brush.Color := Self.Color;
      Brush.Style := bsSolid;
      FillRect(ClientRect);
    end;
    Brush.Style := bsClear;
    Draw3DText (ClientRect,dt_ExpandTabs or TextAlignments[Alignment]);
    If AutoSize then
    begin
      Autosize := False;
      Autosize := True;
    end;
  end;
end;

procedure Register;
begin
  RegisterComponents('Add', [TSerLabel]);
end;

end.
